(function () {
    document.addEventListener("deviceready", function () {
        console.log("device ready.");

        document.getElementById("initBtn").addEventListener("click", init, false);

        document.getElementById("setMinimumSessionIntervalBtn").addEventListener("click", setMinimumSessionInterval30sec, false);
        document.getElementById("setMinimumSessionIntervalZeroBtn").addEventListener("click", setMinimumSessionIntervalZero, false);
        document.getElementById("setMinimumSessionIntervalNegativeBtn").addEventListener("click", setMinimumSessionIntervalNegative, false);

        document.getElementById("setSessionTimeoutIntervalBtn").addEventListener("click", setSessionTimeoutInterval1hour, false);
        document.getElementById("setSessionTimeoutIntervalZeroBtn").addEventListener("click", setSessionTimeoutIntervalZero, false);
        document.getElementById("setSessionTimeoutIntervalNegativeBtn").addEventListener("click", setSessionTimeoutIntervalNegative, false);

        document.getElementById("logEventBtn").addEventListener("click", logEventSet, false);

        document.getElementById("setUserPropertyBtn").addEventListener("click", setUserPropertyJob, false);
        document.getElementById("setUserPropertyNullBtn").addEventListener("click", setUserPropertyNull, false);

        document.getElementById("setUserIDBtn").addEventListener("click", setUserIDTestUser, false);
        document.getElementById("setUserIDNullBtn").addEventListener("click", setUserIDNull, false);

        document.getElementById("setScreenNameLoginBtn").addEventListener("click", setScreenNameLogin, false);
        document.getElementById("setScreenNameTutorialBtn").addEventListener("click", setScreenNameTutorial, false);
        document.getElementById("setScreenNameNullBtn").addEventListener("click", setScreenNameNull, false);

        document.getElementById("getAppInstanceIDBtn").addEventListener("click", getAppInstanceID, false);
        document.getElementById("resetAnalyticsDataBtn").addEventListener("click", resetAnalyticsData, false);
    });

    function dump(id, text) {
        document.getElementById(id).value = text;
    }

    function init() {
        applican.firebaseAnalytics.init(function () {
            dump("dumpArea", "init() success.");
        }, function (error) {
            dump("dumpArea", "init() failure.");
        });
    }

    function setMinimumSessionInterval30sec() {
        setMinimumSessionInterval(30000);
    }

    function setMinimumSessionIntervalZero() {
        setMinimumSessionInterval(0);
    }

    function setMinimumSessionIntervalNegative() {
        setMinimumSessionInterval(-1000);
    }

    function setMinimumSessionInterval(interval) {
        applican.firebaseAnalytics.setMinimumSessionInterval(interval, function () {
            dump("dumpArea", "setMinimumSessionInterval(" + interval + ") success.");
        }, function (error) {
            switch (error.code) {
            case applican.firebaseAnalytics.ERROR_NOT_INITIALIZED:
                break;
            case applican.firebaseAnalytics.ERROR_INVALID_ARGUMENTS:
                break;
            }
            dump("dumpArea", "setMinimumSessionInterval(" + interval + ") failure.");
        });
    }

    function setSessionTimeoutInterval1hour() {
        setSessionTimeoutInterval(3600000);
    }

    function setSessionTimeoutIntervalZero() {
        setSessionTimeoutInterval(0);
    }

    function setSessionTimeoutIntervalNegative() {
        setSessionTimeoutInterval(-1000);
    }

    function setSessionTimeoutInterval(interval) {
        applican.firebaseAnalytics.setSessionTimeoutInterval(interval, function () {
            dump("dumpArea", "setSessionTimeoutInterval(" + interval + ") success.");
        }, function (error) {
            switch (error.code) {
            case applican.firebaseAnalytics.ERROR_NOT_INITIALIZED:
                break;
            case applican.firebaseAnalytics.ERROR_INVALID_ARGUMENTS:
                break;
            }
            dump("dumpArea", "setSessionTimeoutInterval(" + interval + ") failure.");
        });
    }

    function logEventSet() {
        logEvent("test_event", {
            foo: "bar"
        });
    }

    function logEvent(name, params) {
        applican.firebaseAnalytics.logEvent(name, params, function() {
            dump("dumpArea", "logEvent(" + name +") success.");
        }, function (error) {
            switch (error.code) {
            case applican.firebaseAnalytics.ERROR_NOT_INITIALIZED:
                break;
            case applican.firebaseAnalytics.ERROR_INVALID_ARGUMENTS:
                break;
            }
            dump("dumpArea", "logEvent(" + name + ") failure.");
        });
    }

    function setUserPropertyJob() {
        setUserProperty("job", "developer");
    }

    function setUserPropertyNull() {
        setUserProperty(null, null);
    }

    function setUserProperty(name, value) {
        applican.firebaseAnalytics.setUserProperty(name, value, function() {
            dump("dumpArea", "setUserProperty() success.");
        }, function (error) {
            switch (error.code) {
            case applican.firebaseAnalytics.ERROR_NOT_INITIALIZED:
                break;
            case applican.firebaseAnalytics.ERROR_INVALID_ARGUMENTS:
                break;
            }
            dump("dumpArea", "setUserProperty() failure.");
        });
    }

    function setUserIDTestUser() {
        setUserID("test_user_001");
    }

    function setUserIDNull() {
        setUserID(null);
    }

    function setUserID(userId) {
        applican.firebaseAnalytics.setUserID(userId, function() {
            dump("dumpArea", "setUserID() success.");
        }, function (error) {
            switch (error.code) {
            case applican.firebaseAnalytics.ERROR_NOT_INITIALIZED:
                break;
            case applican.firebaseAnalytics.ERROR_INVALID_ARGUMENTS:
                break;
            }
            dump("dumpArea", "setUserID() failure.");
        });
    }

    function setScreenNameLogin() {
        setScreenName("login_screen");
    }

    function setScreenNameTutorial() {
        setScreenName("tutorial_screen");
    }

    function setScreenNameNull() {
        setScreenName(null);
    }

    function setScreenName(name) {
        applican.firebaseAnalytics.setScreenName(name, function() {
            dump("dumpArea", "setScreenName() success.");
        }, function (error) {
            switch (error.code) {
            case applican.firebaseAnalytics.ERROR_NOT_INITIALIZED:
                break;
            case applican.firebaseAnalytics.ERROR_INVALID_ARGUMENTS:
                break;
            }
            dump("dumpArea", "setScreenName() failure.");
        });
    }

    function getAppInstanceID() {
        applican.firebaseAnalytics.getAppInstanceID(function(instanceId) {
            dump("dumpArea", "getAppInstanceID() success. instanceId = " + instanceId);
        }, function (error) {
            switch (error.code) {
            case applican.firebaseAnalytics.ERROR_NOT_INITIALIZED:
                break;
            case applican.firebaseAnalytics.ERROR_INVALID_ARGUMENTS:
                break;
            }
            dump("dumpArea", "getAppInstanceID() failure.");
        });
    }

    function resetAnalyticsData() {
        applican.firebaseAnalytics.resetAnalyticsData(function() {
            dump("dumpArea", "resetAnalyticsData() success.");
        }, function (error) {
            switch (error.code) {
            case applican.firebaseAnalytics.ERROR_NOT_INITIALIZED:
                break;
            case applican.firebaseAnalytics.ERROR_INVALID_ARGUMENTS:
                break;
            }
            dump("dumpArea", "resetAnalyticsData() failure.");
        });
    }
})();

// vim:set ts=4 sts=4 sw=4 et:
